# PY SR Http Message

Статус: в разработке.

## Стандартные рекомендации реализации HTTP сообщений

Пакет описывает общие абстракции для представления HTTP сообщений в соответствии с [RFC 7230](https://tools.ietf.org/html/rfc7230) 
и [RFC 7231](https://tools.ietf.org/html/rfc7231), а также URI для использования с HTTP-сообщениями в соответствии 
с [RFC 3986](https://tools.ietf.org/html/rfc3986). 

HTTP-сообщения являются основой веб-разработки. Веб-браузеры и HTTP-клиенты создают HTTP-запрос, который отправляется 
на веб-сервер, предоставляющий HTTP-ответ. Серверный код получает HTTP-запрос и возвращает ответное сообщение HTTP.

Сообщения HTTP обычно абстрагируются от конечного потребителя, но как разработчики, мы как правило должны знать, как 
они структурированы и как получить доступ к ним или манипулировать ими для выполнения наших задач, будь то выполнение запроса к HTTP API или обработка входящего запроса.

### ABCMessage - сообщения

HTTP-сообщение - это либо запрос от клиента к серверу, либо ответ от сервера клиенту. Это описание определяет 
абстракции для сообщений HTTP `ABCRequest` и `ABCResponse` соответственно.

### ABCStream - потоки данных

HTTP-сообщения состоят из начальной строки, заголовков и тела. Тело HTTP-сообщения может быть очень маленьким или 
чрезвычайно большим. Попытка представить тело сообщения в виде строки может легко занять больше памяти, чем предполагалось, 
поскольку тело должно храниться полностью в памяти. Попытка сохранить тело запроса или ответа в памяти лишила бы 
использование этой реализации возможности работать с большими телами сообщений. `ABCStream` используется для того, 
чтобы скрыть детали реализации при чтении или записи потока данных.

### ABCRequest - запросы

### ABCResponse - ответы

### ABCServerRequest - запросы на стороне сервера

### ABCUploadedFile - загруженные файлы




